function MSE = mcfqr_pri_b_1 (x, d, lambda, tam, N, M)

L = M*N;
efq1 = ones (1, M);
dfq2 = ones (L, M);
a = zeros (L + M, 1);
Ef = zeros (M);
for i =1:M
    Ef(M-i+1, i) = 1;
end
Ef_0 = zeros (M);
for i =1:M
    Ef_0(M-i+1, i) = 1;
end
inv_gamma = 1;
eq1 = 1;
dq2 = ones (L, 1);
sen_p = zeros (L, M);
cos_p = ones (L, M);
cos = ones (L, 1);
sen = zeros (L, 1);
gamma = 1;

q_theta = eye (L + 1, L + 1);

for k = 1 : tam - 1
%     if k == 400
%         k = k
%     end
%     %-------------Iniciar el lazo j (actualizacion de orden)-------------------    
%     %1 (Verificado)
%     %r = inv(Ef)' * (lambda^-.5 * x(k+1,:)' - dfq2' * a (M + 1: L + M));
% 
%     q_theta = eye(L+1,L+1);   
%     for j = 0:(L-1)
%       Qtetalinha=[cos(j+1)       zeros(1,L-1-j)  -sen(j+1)       zeros(1,j)
%                   zeros(L-1-j,1) eye(L-1-j,L-1-j) zeros(L-1-j,1) zeros(L-1-j,j)
%                   sen(j+1)       zeros(1,L-1-j)   cos(j+1)       zeros(1,j)
%                   zeros(j,1)     zeros(j,L-1-j)   zeros(j,1)     eye(j,j)];
%       q_theta=Qtetalinha*q_theta;
%     end
    
    efq1(:) = x(k+1,:);
    for j = 1:N
        for i = 1:M
            for p = 1:M
                temp1 = efq1(p);
                temp2 = lambda^.5 * dfq2 (M * (N - j + 1) - i + 1, p);
                efq1(p) = temp1 * cos(M * (j - 1) + i) - temp2 * sen (M * (j - 1) + i);
                dfq2(M * (N - j + 1) - i + 1, p) = temp1 * sen(M * (j - 1) + i) + temp2 * cos (M * (j - 1) + i);
            end
         end
    end
    
    %r = inv(Ef)' * efq1' / (lambda^.5 * gamma);
    
    %3(Verificado)
    temp_efq1 = efq1;
    for i = 1:M
        temp1 = temp_efq1(i);
        temp2 = lambda^.5 * Ef(M - i + 1, i);
        temp3 = sqrt (temp1^2 + temp2^2);
        sen_pp (i) = temp1/temp3;
        cos_pp (i) = temp2/temp3;
        Ef (M - i + 1, i) = temp3;
        for s = i + 1:M
            temp1 = temp_efq1(s);
            temp2 = lambda^.5 * Ef (M - i + 1, s);
            temp_efq1(s) = temp1 * cos_pp(i) - temp2 * sen_pp(i);
            Ef (M - i + 1, s) = temp1 * sen_pp(i) + temp2 * cos_pp(i);
        end
    end
    
    temp_gamma = 1/gamma;
    for i = 1:M
        r(M - i + 1, 1) = temp_gamma * sen_pp(i) / cos_pp(i);
        temp_gamma = temp_gamma * cos_pp(i) + r(M - i + 1, 1) * sen_pp(i);
    end
    
%     aux_a = a(M+1:L+M);
%     aux_a(M * N + 1:M*N + M) = r;
%     q_theta_p = eye (L+M);
%     for j = 0:L-1
%         for s = 0:M-1
%             q_i = [eye(j)             zeros(j,1)          zeros(j,L+M-j-s-2)          zeros(j,1)            zeros(j,s)
%                    zeros(1,j)         cos_p(j+1,s+1)        zeros(1,L+M-j-s-2)          -sen_p(j+1,s+1)         zeros(1,s)
%                    zeros(L+M-j-s-2,j) zeros(L+M-j-s-2,1)  eye(L+M-j-s-2)              zeros(L+M-j-s-2,1)    zeros(L+M-j-s-2,s)
%                    zeros(1,j)         sen_p(j+1,s+1)        zeros(1,L+M-j-s-2)          cos_p(j+1,s+1)          zeros(1,s)
%                    zeros(s,j)         zeros(s,1)          zeros(s,L+M-j-s-2)          zeros(s,1)            eye(s)
%             ];
%             q_theta_p = q_i * q_theta_p;
%             aux_a = q_i * aux_a;
%         end
%     end
%     a_p = q_theta_p * [a(M+1:L+M);r];
    
    %2(Verificado)
    for j = 1:N
        for i = 1:M
            for s = 1:M
                temp1 = a (M * j + i);
                temp2 = r(M - s + 1);
                a (M * (j - 1) + i) = temp1 * cos_p (M * (j - 1) + i, s) - temp2 * sen_p (M * (j - 1) + i, s);
                a (M * j + i) = a (M * (j - 1) + i);
                r (M - s + 1) = temp1 * sen_p (M * (j - 1) + i, s) + temp2 * cos_p (M * (j - 1) + i, s);
            end
        end
    end
    a(M * N + 1:M*N + M) = r;   
    %aux = inv(Ef_0)' * x(k+1,:)'/(lambda^(.5));
    
    %4 (Verificado)
    Ef_0 = Ef;
    temp_dfq2 = dfq2;
    for j = 1:N
        for i = 1:M
            for s = 1:M
                %calcular sen_p y cos_p (j, i)
                temp1 = temp_dfq2 (M * (j - 1) + i, s);
                temp2 = Ef_0 (M - s + 1, s);
                sen_p (M * (j - 1) + i, s) = temp1 / sqrt (temp1^2 + temp2^2);
                cos_p (M * (j - 1) + i, s) = temp2 / sqrt (temp1^2 + temp2^2);
                Ef_0 (M - s + 1, s) = sqrt (temp1^2 + temp2^2);
                for p = s + 1:M
                    temp1 = temp_dfq2 (M * (j - 1) + i, p);
                    temp2 = Ef_0 (M - s + 1, p);
                    temp_dfq2 (M * (j - 1) + i, p) = temp1 * cos_p(M * (j - 1) + i, s) - temp2 * sen_p(M * (j - 1) + i, s);
                    Ef_0 (M - s + 1, p) = temp1 * sen_p(M * (j - 1) + i, s) + temp2 * cos_p(M * (j - 1) + i, s);
                end
            end
        end
    end
    
    %5 (Verificado)   
    inv_gamma = 1;
    for j = 1:N    
        for i = 1:M
            temp1 = inv_gamma;
            temp2 = a (M * (N - j + 2 ) - i + 1);
            temp3 = sqrt (temp1^2 + temp2^2);
            sen (M * (j - 1) + i) = temp2 / temp3;
            cos (M * (j - 1) + i) = temp1 / temp3;
            inv_gamma = temp1 * cos(M * (j - 1) + i) + temp2 * sen(M * (j - 1) + i);
        end
    end
    gamma = 1/inv_gamma;
        
    %6 (Verificado)
    eq1 = d(k+1);
    for j = 1:N
        for i = 1:M
            temp1 = eq1;
            temp2 = lambda^.5 * dq2(M * (N - j + 1) - i + 1);
            eq1 = temp1 * cos (M * (j - 1) + i) - temp2 * sen(M * (j - 1) + i);
            dq2(M * (N - j + 1) - i + 1) = temp1 * sen (M * (j - 1) + i) + temp2 * cos(M * (j - 1) + i);
        end
    end
    
    %7 (Verificado)
    e (k+1) = eq1 / (realmin + gamma);
end

MSE = e;