clear
ENS = 1;
tam = 1000;
lambda = .95;

N = 5;
M = 2;

MSE_pri_1 = zeros(tam, 1);
%MSE_pri_2 = zeros(tam, 1);
%MSE_pos_1 = zeros(tam, 1);
%MSE_pos_2 = zeros(tam, 1);
%MSE_rls = zeros(tam, 1);
cn = 0;
for i = 1 : ENS
    disp (i)
    
    x = randn (tam, M);
    x = sqrt (1) * x;  %0 dB de Potencia
    for j = 1:M
        x(:,j) = filter (1, [1, -.95], x(:,j));
        cn_temp = achacn (x(:,j), N);
        cn = cn + cn_temp;
    end
    
    Wopt = randn(M,N);
    d = zeros (tam, 1);
    for j = 1:M
        d = d + filter (Wopt (j, :), 1, x (:, j));
    end
    
    d = d + sqrt (1e-4) * randn (tam,1);    %ruido -70 dB de potencia

    %Varios versiones de filtrage FQR
    %FQR_PRI_B_1
    MSE = mcfqr_pri_b_1 (x, d, lambda, tam, N, M);
    
    MSE_pri_1 = MSE_pri_1 + MSE'.^2;
    
    %FQR_PRI_B_2
    %MSE = mcfqr_pri_b_2 (x, d, lambda, tam, N, M);
    
    %MSE_pri_2 = MSE_pri_2 + MSE';
    
    %FQR_POS_B_1
    %MSE = mcfqr_pos_b_1 (x, d, lambda, tam, N, M);
    
    %MSE_pos_1 = MSE_pos_1 + MSE'.^2;
    
    %FQR_POS_B_2
    %MSE = mcfqr_pos_b_2 (x, d, lambda, tam, N, M);
    
    %MSE_pos_2 = MSE_pos_2 + MSE';
    
    % Conventional RLS Algorithm:
%      wRLS=zeros(N * M,1);
%      S=0.001*eye(N * M);
%      X=zeros(M * N,1);
%      for k=1:tam
%          X=[x(k, :)'; X(1:M * (N - 1))];
%          eprime=d(k)-X'*wRLS;
%          Psi=S*X;
%          S=(1/lambda)*(S-Psi*Psi'/(lambda+Psi'*X));
%          wRLS=wRLS+eprime*S*X;
%          %yRLS=wRLS'*X;
%          %eRLS=d(k)-yRLS;
%          MSE_rls(k)=MSE_rls(k)+eprime^2;%eRLS^2;
%      end
end
% 
MSE_pri_1 = MSE_pri_1 (2:max(size(MSE_pri_1))) / ENS;
% MSE_pri_2 = MSE_pri_2 (2:max(size(MSE_pri_2))) / ENS;
% MSE_pos_1 = MSE_pos_1 (2:max(size(MSE_pos_1))) / ENS;
% MSE_pos_2 = MSE_pos_2 (2:max(size(MSE_pos_2))) / ENS;
% MSE_rls = MSE_rls (2:max(size(MSE_rls))) / ENS;
% 
% plot (10*log10(MSE_rls));
% hold on
 plot (10*log10(MSE_pri_1), 'r');
% plot (10*log10(MSE_pri_2), 'g');
% plot (10*log10(MSE_pos_1), 'k');
% plot (10*log10(MSE_pos_2), 'm');
% 
% legend ('RLS', 'FQR\_PRI\_B(V.1)', 'FQR\_PRI\_B(V.2)', 'FQR\_POS\_B(V.1)', 'FQR\_POS\_B(V.2)');
% 
% xlabel ('k');
% ylabel ('MSE_{dB}');
% title ('Learning Curve');

xlabel ('k');
ylabel ('MSE_{dB}');
disp('Condition Number of input signals')
cn = cn/(ENS*M)